# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetTwingateResourceResult',
    'AwaitableGetTwingateResourceResult',
    'get_twingate_resource',
    'get_twingate_resource_output',
]

@pulumi.output_type
class GetTwingateResourceResult:
    """
    A collection of values returned by getTwingateResource.
    """
    def __init__(__self__, address=None, approval_mode=None, id=None, name=None, protocols=None, remote_network_id=None, tags=None, usage_based_autolock_duration_days=None):
        if address and not isinstance(address, str):
            raise TypeError("Expected argument 'address' to be a str")
        pulumi.set(__self__, "address", address)
        if approval_mode and not isinstance(approval_mode, str):
            raise TypeError("Expected argument 'approval_mode' to be a str")
        pulumi.set(__self__, "approval_mode", approval_mode)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if protocols and not isinstance(protocols, dict):
            raise TypeError("Expected argument 'protocols' to be a dict")
        pulumi.set(__self__, "protocols", protocols)
        if remote_network_id and not isinstance(remote_network_id, str):
            raise TypeError("Expected argument 'remote_network_id' to be a str")
        pulumi.set(__self__, "remote_network_id", remote_network_id)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if usage_based_autolock_duration_days and not isinstance(usage_based_autolock_duration_days, int):
            raise TypeError("Expected argument 'usage_based_autolock_duration_days' to be a int")
        pulumi.set(__self__, "usage_based_autolock_duration_days", usage_based_autolock_duration_days)

    @property
    @pulumi.getter
    def address(self) -> builtins.str:
        """
        The Resource's address, which may be an IP address, CIDR range, or DNS address
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="approvalMode")
    def approval_mode(self) -> builtins.str:
        """
        The Approval Mode of the Resource. The valid values are `AUTOMATIC` and `MANUAL`.
        """
        return pulumi.get(self, "approval_mode")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The ID of the Resource. The ID for the Resource can be obtained from the Admin API or the URL string in the Admin Console.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the Resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def protocols(self) -> Optional['outputs.GetTwingateResourceProtocolsResult']:
        """
        By default (when this argument is not defined) no restriction is applied, and all protocols and ports are allowed.
        """
        return pulumi.get(self, "protocols")

    @property
    @pulumi.getter(name="remoteNetworkId")
    def remote_network_id(self) -> builtins.str:
        """
        The Remote Network ID that the Resource is associated with. Resources may only be associated with a single Remote Network.
        """
        return pulumi.get(self, "remote_network_id")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, builtins.str]:
        """
        The `tags` attribute consists of a key-value pairs that correspond with tags to be set on the resource.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="usageBasedAutolockDurationDays")
    def usage_based_autolock_duration_days(self) -> builtins.int:
        """
        The number of days that the Resource will be locked after the last successful login.
        """
        return pulumi.get(self, "usage_based_autolock_duration_days")


class AwaitableGetTwingateResourceResult(GetTwingateResourceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTwingateResourceResult(
            address=self.address,
            approval_mode=self.approval_mode,
            id=self.id,
            name=self.name,
            protocols=self.protocols,
            remote_network_id=self.remote_network_id,
            tags=self.tags,
            usage_based_autolock_duration_days=self.usage_based_autolock_duration_days)


def get_twingate_resource(id: Optional[builtins.str] = None,
                          protocols: Optional[Union['GetTwingateResourceProtocolsArgs', 'GetTwingateResourceProtocolsArgsDict']] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTwingateResourceResult:
    """
    Resources in Twingate represent any network destination address that you wish to provide private access to for users authorized via the Twingate Client application. Resources can be defined by either IP or DNS address, and all private DNS addresses will be automatically resolved with no client configuration changes. For more information, see the Twingate [documentation](https://docs.twingate.com/docs/resources-and-access-nodes).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_twingate as twingate

    foo = twingate.get_twingate_resource(id="<your resource's id>")
    ```


    :param builtins.str id: The ID of the Resource. The ID for the Resource can be obtained from the Admin API or the URL string in the Admin Console.
    :param Union['GetTwingateResourceProtocolsArgs', 'GetTwingateResourceProtocolsArgsDict'] protocols: By default (when this argument is not defined) no restriction is applied, and all protocols and ports are allowed.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['protocols'] = protocols
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('twingate:index/getTwingateResource:getTwingateResource', __args__, opts=opts, typ=GetTwingateResourceResult).value

    return AwaitableGetTwingateResourceResult(
        address=pulumi.get(__ret__, 'address'),
        approval_mode=pulumi.get(__ret__, 'approval_mode'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        protocols=pulumi.get(__ret__, 'protocols'),
        remote_network_id=pulumi.get(__ret__, 'remote_network_id'),
        tags=pulumi.get(__ret__, 'tags'),
        usage_based_autolock_duration_days=pulumi.get(__ret__, 'usage_based_autolock_duration_days'))
def get_twingate_resource_output(id: Optional[pulumi.Input[builtins.str]] = None,
                                 protocols: Optional[pulumi.Input[Optional[Union['GetTwingateResourceProtocolsArgs', 'GetTwingateResourceProtocolsArgsDict']]]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetTwingateResourceResult]:
    """
    Resources in Twingate represent any network destination address that you wish to provide private access to for users authorized via the Twingate Client application. Resources can be defined by either IP or DNS address, and all private DNS addresses will be automatically resolved with no client configuration changes. For more information, see the Twingate [documentation](https://docs.twingate.com/docs/resources-and-access-nodes).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_twingate as twingate

    foo = twingate.get_twingate_resource(id="<your resource's id>")
    ```


    :param builtins.str id: The ID of the Resource. The ID for the Resource can be obtained from the Admin API or the URL string in the Admin Console.
    :param Union['GetTwingateResourceProtocolsArgs', 'GetTwingateResourceProtocolsArgsDict'] protocols: By default (when this argument is not defined) no restriction is applied, and all protocols and ports are allowed.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['protocols'] = protocols
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('twingate:index/getTwingateResource:getTwingateResource', __args__, opts=opts, typ=GetTwingateResourceResult)
    return __ret__.apply(lambda __response__: GetTwingateResourceResult(
        address=pulumi.get(__response__, 'address'),
        approval_mode=pulumi.get(__response__, 'approval_mode'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        protocols=pulumi.get(__response__, 'protocols'),
        remote_network_id=pulumi.get(__response__, 'remote_network_id'),
        tags=pulumi.get(__response__, 'tags'),
        usage_based_autolock_duration_days=pulumi.get(__response__, 'usage_based_autolock_duration_days')))
